//   Professional File

////////////////////////////////////////////////////
// RenriVer 8.74  DllLibrary Arduino  0.05         //
// c source builder by  SEQ_CBuilder V             //
// TargetCPU = ESP32(WROOM32) Library=M5Stack      //
// make  MMonitorx.ino File  2020/03/02 05:43 //
////////////////////////////////////////////////////
// device_list //
 // X0037 	X0038 	X0039 	// XDevice = 3
 // Y0026 	// YDevice = 1 
 // M0000 	M0001 	// MDevice = 2  
 // D0000 	// DDevice = 1  
 // T0000 	// TDevice = 1  
 // C0001 	// CDevice = 1  
 // // LDevice = 0  
 // // rDevice = 0  
 // J000000 	J000100 	// jDevice = 2 
//// device_list //

#include  <M5Stack.h>
#include "MMonitorx.h";

HardwareSerial mySerial1(1);  // 連枝のデバッグ用シリアルポート


// マイコンが起動するときに１度だけ呼び出される関数です。
// 主に初期化処理やデバイスの初期化のプログラムをユーザー側で作成します。
void setup(){
	 byte		tmp;

	 // M5Stackを使用する前の初期化関数の呼び出し
	 M5.begin();
	 dacWrite(25,0); // Speakerの出力を消す
	 
	 // プログラム書込みのシリアルポートを使用する場合は、以下の行のコメントを削除してください。
	 // Serial.begin(115200);
	 // Serial.println("setup start");


   mySerial1.begin(19200,SERIAL_8N1,17,16);  // パソコン側のシリアル(オンボードデバッグ用)
	 for (byte i=0; i<sizeof(in_no); i++) {
	 	 pinMode(in_no[i],INPUT);
	 }
	 
	 input_refresh();		// 入力更新処理
	 
	 for (byte i=0; i<sizeof(out_no); i++) {
	 	 pinMode(out_no[i],OUTPUT);
	 } 
	 
	 lasttime = micros(); // 時間の取得（ us単位 ）
	 lasttime_ms = millis(); // 時間の取得（ ms単位 )
	 q = 0x01;
	 SET_E_ON(M9038,0);     //  1スキャンＯＮリレーの生成
	 SET_E_ON(M9036,0);     //  常時ＯＮリレーの生成
	 SET_E_OFF(M9037,0);    // 常時ＯＦＦリレーの生成
	  M5.Lcd.init();	// TFTの初期化関数の呼び出し
	  tftInit();
	 // Serial.println("setup end");
}


// Ａｒｄｕｉｎｏがプログラムの実行時、繰り返し呼び出す関数です。
// loop関数の処理が終わるとＡｒｄｕｉｎｏの必要な処理を行います。
// その処理が終われば、再度Ａｒｄｕｉｎｏがloop関数を呼び出します。
////////////////////////////// Loop 開始(スキャンプログラム) //////////////////////////////
void loop(){			// 

  static uint16_t dataLength;
  static uint8_t stxFlag=0;   

	 int tmp;				// 
	 time_refresh();		// 時間の更新処理
	 link_refresh();		//	リンクリフレッシュ処理
	 special_refresh();	// 特殊リレーの更新処理
	 output_refresh();	// 出力更新処理
	 input_refresh();		// 入力更新処理
	 ldlg = 0x0; //  ブロック用変数;
	 aax = 0x0;  // 回路の状態保持変数;
	 trlg = 0x0; // ＭＰＳ／ＭＲＤ／ＭＰＰ;
	 iix = 0x01; // ＭＣ用変数の初期化;
	 ;
// LD
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_X(X0037,37);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// TIM 
	 if (aax & iix) { 
	 	 if (!GET_UTRG(UTRG0000,0)) { 
	 	 	 SET_UTRG_ON(UTRG0000,0);
	 	 } else { 
	 	 	 if ((t_count[0] + (spantime) ) >=  5 * 100000){
	 	 	 	 t_count[0] = 5 * 100000; 
	 	 	 	 SET_T_ON(T0000,0);
	 	 	 } else {
	 	 	 	 t_count[0] += spantime; 
	 	 	 }
	 	 }
	 } else {
	 	 t_count[0] = 0;
	 	 SET_T_OFF(T0000,0);
	 	 SET_UTRG_OFF(UTRG0000,0);
	 }
	 
// LD
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_X(X0038,38);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// CNT 
	 if (aax & iix) { 
	 	 if (!GET_UTRG(UTRG0001,1)) { 
	 	 	 if(!GET_C(C0001,1)) { 
	 	 	 if (c_count[1] <  8 ) { 
	 	 	 	 c_count[1] ++; 
	 	 	 	 if (c_count[1] >= 8) { 
	 	 	 	 	 SET_C_ON(C0001,1);
	 	 	 	 } 
	 	 	 } else { 
	 	 	 	 
	 	 	 }
	 	 	 }
	 	 	 SET_UTRG_ON(UTRG0001,1);
	 	 } else { 
	 	 } 
	 } else {
	 	 SET_UTRG_OFF(UTRG0001,1);
	 }
	 
// LD
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_J(0x0000);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// OUT 
	 if (aax & iix) { 
	 	 // 条件が成立時マイスキャン実行されます。
	 	 SET_Y_ON(Y0026,26);
	 } else { 
	 	 // 条件が不成立時マイスキャン実行されます。
	 	 SET_Y_OFF(Y0026,26);
	 }
	 
// LD
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_X(X0037,37);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// OUT 
	 if (aax & iix) { 
	 	 // 条件が成立時マイスキャン実行されます。
	 	 SET_J_ON(0x0000);
	 } else { 
	 	 // 条件が不成立時マイスキャン実行されます。
	 }
	 
// LD
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_X(X0039,39);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// OUT 
	 if (aax & iix) { 
	 	 // 条件が成立時マイスキャン実行されます。
	 	 SET_J_ON(0x0001);
	 } else { 
	 	 // 条件が不成立時マイスキャン実行されます。
	 }
	 
// LD
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_J(0x0000);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// OUT 
	 if (aax & iix) { 
	 	 // 条件が成立時マイスキャン実行されます。
	 	 SET_M_ON(M0000,0);
	 } else { 
	 	 // 条件が不成立時マイスキャン実行されます。
	 	 SET_M_OFF(M0000,0);
	 }
	 
// LD
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_J(0x0001);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// OUT 
	 if (aax & iix) { 
	 	 // 条件が成立時マイスキャン実行されます。
	 	 SET_M_ON(M0001,1);
	 } else { 
	 	 // 条件が不成立時マイスキャン実行されます。
	 	 SET_M_OFF(M0001,1);
	 }
	 
// LD
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_X(X0039,39);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// OR 
	 flag = GET_T(T0000,0);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// OR 
	 flag = GET_C(C0001,1);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// INC BCDデータのインクリメント命令
	 if (aax & iix) { 
	 	 if (!GET_UTRG(UTRG0002, 2)) { 
	 	 	 int tmpB = bcdbin(D0000);
	 	 	 if(tmpB==9999){
 	 	 	 	 tmpB=0;
	 	 	 } else {
	 	 	 	 tmpB++; 
	 	 	 }
	 	 	 D0000 = binbcd(tmpB);
	 	 	 SET_UTRG_ON(UTRG0002,2);
	 	 } else {
	 	 }
	 } else {
	 	 	 SET_UTRG_OFF(UTRG0002,2);
	 } 
// LD
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_X(X0039,39);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// RST 
	 if (aax & iix) { 
	 	 SET_C_OFF(C0001,1);
	 	 c_count[1]=0; 
	 } 
// END 
	 output_refresh();	// 出力更新処理
//	 M5.update(); 
	// Serial.println();
	 SET_E_OFF(M9038,0);

 if (mySerial1.available()) {
    while(mySerial1.available()){
      int inByte = mySerial1.read();
			if ((stxFlag & 0x01) == 0) {  //  stx受信フラグがあるかどうかのチェック 0なし、1あり		
				if (inByte == 0x02) { //  １回目のＳＴＸ受信時		
					stxFlag = 1;    // STX受信フラグのセット		
					rvData[inposrc++] = (uint8_t)inByte;  // 受信データを格納		
				}		
				else {		
					inposrc = 0;		
					stxFlag = 0;		
				}		
			}		
			else {  // データサイズ受信フラグ判定		
				if ((stxFlag & 0x02) == 0) {  //  // データ長受信フラグがあるか判定 　0なし、2あり		
					rvData[inposrc++] = (uint8_t)inByte;    // 受信データを受信バッファにセット		
					dataLength = (uint8_t)inByte & 0x7F;  // データサイズをセット		
					stxFlag |= 0x02;    // データ長受信フラグありに変更		
				}		
				else {  // データサイズ受信フラグあり		
					rvData[inposrc++] = (uint8_t)inByte;    // 受信データを受信バッファにセット		
					if (dataLength < (inposrc - 4)) { // 受信データの位置が受信予定サイズより大きくなったら		
						inposrc = 0;            // 位置をクリアする		
						stxFlag = 0;            // 受信フラグをクリア		
					}		
					else if ((inposrc - 4) < dataLength) { // dataLengthより短い場合、データがそろっていない		
					}		
					else if (rvData[inposrc - 1] == 0x03) { // 終端文字ＥＴＸを受信したとき		
						int ressize;		
						ressize = AnalyzePacket(rvData, inposrc);		// 連枝からのモニタ要求に対する応答のデータ生成とデータ作成
						if (ressize>0) {		
							for (int sendcount = 0; sendcount < ressize; sendcount++) {		
								mySerial1.write(txData[sendcount]);		
							}		
						}		
						inposrc = 0;  // 位置をクリアする		
						stxFlag = 0;  //受信フラグをクリア		
					}		
					else {		
						// 受信予定サイズだけど、ETXじゃない場合   		
					}		
				}		
			}		
		}		
	}		


	
}
////////////////////////////// Loop 終了 //////////////////////////////
